//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  IdFTPR|gpăT[o̎wfBNg̃t@CXg쐬
//
//  IdFTPList\bhgpăXgDirectoryListingɎ擾ď
//  ListViewɕ\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2007N1116
//    EJ
//
//  2011N0121
//    EDelphi 2010, XE, Indy 10.5.7ȍ~Ή̃R[hɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro + Indy 10 (Ver 10.5.7)
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ImgList, WinInet, Buttons,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdFTP,
  IdExplicitTLSClientServerBase, IdAllFTPListParsers;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    Panel1: TPanel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    btnConnect: TButton;
    StatusBar1: TStatusBar;
    IdFTP1: TIdFTP;
    btnBackDir: TButton;
    btnCreateDir: TButton;
    btnDelete: TButton;
    btnPermission: TButton;
    btnReName: TButton;
    procedure btnConnectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure btnBackDirClick(Sender: TObject);
    procedure btnCreateDirClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnPermissionClick(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure btnReNameClick(Sender: TObject);
  private
    { Private 錾 }
    FIniFileName  : String;
    procedure SetListViewItems;
    function GetFileExtIcon(FileName: String; Attrib:Cardinal): Integer;
    procedure ChangeDir(DirName: String);
    procedure SetButtonsEnabled(Flag: Boolean);
  public
    { Public 錾 }
  end;

  function ItemsSort(Item1,Item2:TListItem; ParamSort:integer): Integer;stdcall;

var
  Form1: TForm1;

implementation

uses
  ShellAPI, CommCtrl, IniFiles, IdFTPList, HTTPApp, Math, DateUtils,
  IdFTPCommon, PermFormUnit;

var
  //\[g֌W̕ϐ
  //SortColum̓\[gJԍƂɃ\[gێ
  //SortColumnIndex̓\[gJ̃CfbNX
  SortColum       : array[0..2] of integer;
  SortColumnIndex : Integer;

{$R *.dfm}

//=============================================================================
//  t@Cꗗ\pListView1̃J̐ݒ
//  EditFTP֌WZbg(1̊KwFTPInfo.iniǂݏoăZbg)
//
//  LabeledEdit4.Text̓t@C̃Xg擾fBNg
//  ex. LabeledEdit4.Text := '/mrxray.on.coocan.jp/homepage/Halbow';
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LIni           : TInifile;
  LSHFileInfo    : TSHFileInfo ;
  LImgListHandle : THandle;
  i              : Integer;
begin
  SetButtonsEnabled(False);
  btnConnect.Enabled := True;

  //sŜI\Ƃ
  ListView1.HideSelection := False;
  ListView1.RowSelect     := True;
  //eXgȂ̂ŕsIs
  ListView1.MultiSelect := False;
  //lɒڕҏW͕s
  ListView1.ReadOnly := True;

  FIniFileName := '..\FTPInfo.ini';
  LIni         := TIniFile.Create(FIniFileName);
  try
   if FileExists(FIniFileName) then begin
     LabeledEdit1.Text := LIni.ReadString('FTPInfo', 'ServerName', '');
     LabeledEdit2.Text := LIni.ReadString('FTPInfo', 'UserID',     '');
     LabeledEdit3.Text := LIni.ReadString('FTPInfo', 'PassWord',   '');
     LabeledEdit4.Text := LIni.ReadString('Others',  'InitDir',    '');
   end;
  finally
    FreeAndNil(LIni);
  end;

  ListView1.ViewStyle := vsReport;

  ListView1.Columns.Add;
  ListView1.Columns[0].Caption   := 't@C';
  ListView1.Columns[0].Width     := 190;

  ListView1.Columns.Add;
  ListView1.Columns[1].Caption   := 'TCY@';
  ListView1.Columns[1].Width     := 100;
  ListView1.Columns[1].Alignment := taRightJustify;

  ListView1.Columns.Add;
  ListView1.Columns[2].Caption := '@XV';
  ListView1.Columns[2].Width   := 120;

  //VXẽC[WXg̃nh擾
  LImgListHandle := SHGetFileInfo('',
                                  0,
                                  LSHFileInfo,
                                  SizeOf(LSHFileInfo),
                                  SHGFI_SMALLICON or
                                  SHGFI_SYSICONINDEX);
  ListView_SetImageList(ListView1.Handle, LImgListHandle, LVSIL_SMALL);

  //\[gŎgpzlɑ
  //\[gΏۃJ̏l0(ÕJ)
  SortColumnIndex := 0;
  for i := 0 to Length(SortColum) - 1 do begin
    SortColum[i] := 1;
  end;
end;

//=============================================================================
//  ݒInit@Cɕۑ
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  LIni : TInifile;
begin
  LIni := TIniFile.Create(FIniFileName);
  try
    try
      LIni.WriteString('FTPInfo', 'ServerName', LabeledEdit1.Text);
      LIni.WriteString('FTPInfo', 'UserID',     LabeledEdit2.Text);
      LIni.WriteString('FTPInfo', 'PassWord',   LabeledEdit3.Text);
      LIni.WriteString('Others',  'InitDir',    LabeledEdit4.Text);
    except
    end;
  finally
    FreeAndNil(LIni);
  end;
end;

//=============================================================================
//  ڑFTPT[o̎wfBNg̈ꗗ擾
//  t@C̃Xg쐬ChangeDir\bhSetLiestViewItemsōs
//=============================================================================
procedure TForm1.btnConnectClick(Sender: TObject);
begin
  SetButtonsEnabled(False);

  if IdFTP1.Connected then begin
    btnConnect.Enabled := True;
    IdFTP1.Disconnect;
    btnConnect.Caption := 'ڑ';
    ListView1.Items.Clear;
  end else begin
    IdFTP1.Host     := LabeledEdit1.Text;
    IdFTP1.Username := LabeledEdit2.Text;
    IdFTP1.Password := LabeledEdit3.Text;

    try
      IdFTP1.Connect;
      ChangeDir(LabeledEdit4.Text);
    except
      MessageDlg('ڑɎs܂D', mtInformation, [mbOK], 0);
      raise;
    end;

    if IdFTP1.Connected then begin
      btnConnect.Caption := 'ؒf';
    end else begin
      btnConnect.Caption := 'ڑ';
      ListView1.Items.Clear;
    end;
  end;

  SetButtonsEnabled(True);
  btnConnect.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  ListViewɃt@C̏\
//  TIdFTPListItem̎gpɂusesIdFTPListKv
//
//  [l]
//  t@C̎ʂʂTIdFTPListItemItemTypevpeB̒l
//  TIdDirItemType = (ditDirectory, ditFile, ditSymbolicLink);
//-----------------------------------------------------------------------------
procedure TForm1.SetListViewItems;
var
  LFileName   : String;
  LSize       : Integer;
  i           : Integer;
  LFTPItem    : TIdFTPListItem;
  LItem       : TListItem;
  LFileAttrib : Cardinal;
begin
  if not Assigned(IdFTP1.DirectoryListing) then exit;

  Screen.Cursor := crHourGlass;
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;

  for i := 0 to IdFTP1.DirectoryListing.Count - 1 do begin
    LFTPItem := IdFTP1.DirectoryListing.Items[i];

    //t@C
    LFileName := LFTPItem.FileName;

    //t@C'.'܂'..'̎͏O
    if (LFileName = '.') or (LFileName = '..') then Continue;
    LItem := ListView1.Items.Add;

    //t@C
    LItem.Caption := LFileName;

    //\[gŎgp邽߂DatavpeBɒl
    //DatavpeB̃̈OnDeletionCxgŎs
    LItem.Data := LFTPItem;

    //t@CTCY
    LSize := LFTPItem.Size;
    if LFTPItem.ItemType = ditDirectory then begin
      LItem.SubItems.Add('');
    end else begin
      LItem.SubItems.Add(FormatFloat('###,##0 KB', LSize));
    end;

    //t@C̍XV
    LItem.SubItems.Add(FormatDateTime(' yyyy/mm/dd hh:nn', LFTPItem.ModifiedDate));

    //t@C̊gqɉACR\
    LFileAttrib := 0;
    if LFTPItem.ItemType = ditDirectory then begin
      LFileAttrib := FILE_ATTRIBUTE_DIRECTORY;
    end else
    if LFTPItem.ItemType = ditFile then begin
      LFileAttrib := FILE_ATTRIBUTE_NORMAL;
    end;
    LFileName := ExtractFileName(UnixPathToDosPath(LFTPItem.FileName));
    LItem.ImageIndex := GetFileExtIcon(LFileName, LFileAttrib);
  end;

  //t@C擾\[g
  //\[gΏۃJ݂͌Ɠŏ~̂܂
  ListView1.CustomSort(@ItemsSort, 0);

  ListView1.Items.EndUpdate;
  ListView1.Selected    := nil;
  ListView1.ItemFocused := nil;
  Screen.Cursor         := crDefault;
  //݂̃fBNg\
  LabeledEdit4.Text := IdFTP1.RetrieveCurrentDir;
end;

//-----------------------------------------------------------------------------
//  t@C̊gqɊ֘AtVXeC[WACR̃CfbNX擾
//  FileName̓t@C̃tpX(pX͂ȂĂ)
//  擾t@C̑Attribɗ^
//-----------------------------------------------------------------------------
function TForm1.GetFileExtIcon(FileName: String; Attrib:Cardinal): Integer;
var
  LSHFileInfo : TSHFileinfo;
begin
  SHGetFileInfo(PChar('*' + ExtractFileExt(Filename)),
                      Attrib,
                      LSHFileInfo,SizeOf(TSHFileInfo),
                      SHGFI_USEFILEATTRIBUTES or
                      SHGFI_SYSICONINDEX      or
                      SHGFI_SMALLICON);
  Result := LSHFileInfo.iIcon;
end;

//=============================================================================
//  ListView̃JNbNŃ\[g
//  SortColum̓\[gJԍƂɃ\[gێ(1܂-1)
//  SortColumnIndex̓\[gJ̃CfbNX
//=============================================================================
procedure TForm1.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  SetButtonsEnabled(False);
  if ListView1.Items.Count > 0 then begin
    SortColumnIndex:=Column.Index;
    //JNbNxɃ\[gtɂ(gO)
    SortColum[SortColumnIndex] := - SortColum[SortColumnIndex];
    ListView1.CustomSort(@ItemsSort, 0);
  end;
  ListView1.Selected := nil;
  SetButtonsEnabled(True);
end;

//=============================================================================
//  [߂]{^
//  P̊Kw̃fBNgɈړ
//=============================================================================
procedure TForm1.btnBackDirClick(Sender: TObject);
begin
  if not IdFTP1.Connected then exit;

  SetButtonsEnabled(False);
  IdFTP1.ChangeDirUp;
  ChangeDir('');
  SetButtonsEnabled(True);
end;

//=============================================================================
//  [fBNg쐬]{^
//  ݂̃fBNgɐVfBNg쐬
//  쐬烊XgĎ擾āC쐬fBNg悤ɂ
//  eXgȂ̂ō쐬̓̓_CAO\
//  pIɂItem̃LvVŒڕҏW낤
//=============================================================================
procedure TForm1.btnCreateDirClick(Sender: TObject);
var
  LDir  : String;
  LItem : TListItem;
begin
  if not IdFTP1.Connected then exit;

  if InputQuery('fBNg쐬', 'fBNg', LDir) then begin
    if Trim(LDir) <> '' then begin
      IdFTP1.MakeDir(LDir);
      ChangeDir(IdFTP1.RetrieveCurrentDir);
      LItem := ListView1.FindCaption(0, LDir, True, True, True);
      if LItem <> nil then begin
        ListView1.Items[LItem.Index].MakeVisible(True);
        ListView1.ItemIndex := LItem.Index;
      end;
    end;
  end;
end;

//=============================================================================
//  [OύX]
//  OύX̎̓Xg̍Ď擾͕KvȂ
//  Kvȃf[^͑SListVieẘeItemɕێĂ
//  eXgȂ̂ŖO̓̓_CAO\
//  pIɂItem̃LvVŒڕҏW낤
//=============================================================================
procedure TForm1.btnReNameClick(Sender: TObject);
var
  LOldName : String;
  LName    : String;
  LItem    : TListItem;
begin
  if not IdFTP1.Connected then exit;
  if ListView1.Selected=nil then exit;

  LItem   := ListView1.Selected;
  LOldName := LItem.Caption;
  LName   := LOldName;
  if InputQuery('O̕ύX', 'ύX̖O', LName) then begin
    if Trim(LName) <> '' then begin
      IdFTP1.Rename(LOldName, LName);
      ListView1.Selected.Caption := LName;
      //ListViewItemDatavpeB̒lXV
      TIdFTPListItem(ListView1.Items[LItem.Index].Data).FileName := LName;
    end;
  end;
end;

//=============================================================================
//  [폜]
//  ݑI𒆂̃t@C폜
//  Xg̍Ď擾͕KvȂ
//  Kvȃf[^͑SListVieẘeItemɕێĂ
//  eXg1IłȂ悤ɂȂĂ̂Ŗ{R[h1̏ꍇ̏
//=============================================================================
procedure TForm1.btnDeleteClick(Sender: TObject);
var
  LItem    : TListItem;
  LFTPItem : TIdFTPListItem;
begin
  if not IdFTP1.Connected     then exit;
  if ListView1.Selected = nil then exit;

  LItem    := ListView1.Selected;
  LFTPItem := TIdFTPListItem(ListView1.Items[LItem.Index].Data);
  if LFTPItem.ItemType = ditDirectory then begin
    try
      IdFTP1.RemoveDir(LItem.Caption);
      //ListVieẘYItem폜
      LItem.Delete;
      ListView1.Selected    := nil;
      ListView1.ItemFocused := nil;
    except
      //ۂɂ͍폜̌ȂꍇG[
      MessageDlg('fBNgł͂܂D', mtInformation, [mbOK], 0);
    end;
  end else begin
    IdFTP1.Delete(LItem.Caption);
    //ListVieẘYItem폜
    LItem.Delete;
    ListView1.Selected    := nil;
    ListView1.ItemFocused := nil;
  end;
end;

//=============================================================================
//  [ANZX]{^
//  t@C̃ANZX(p[~bV)̕\Ɛݒ
//  ݒ\p̃tH[(_CAO)\
//  chmode(Change ModëӖ?)R}h̃t@C̓tpXłȂƎs
//
//  Iēɐݒ肵ꍇ́CI𒆂̍s[vĂ̏ƂȂ
//=============================================================================
procedure TForm1.btnPermissionClick(Sender: TObject);
var
  LItem       : TListItem;
  LFileName   : String;
  LCmdStr     : String;
  LCurrentDir : String;
begin
  if not IdFTP1.Connected     then exit;
  if ListView1.Selected = nil then exit;

  PermForm := TPermForm.Create(Self);
  try
    LItem := ListView1.Selected;
    //p[~bV(ANZX)ݒ_CAO\
    //ł̓eXgȂ̂őIItem1Ƃď
    PermForm.FPermStr := TIdFTPListItem(LItem.Data).PermissionDisplay;

    if PermForm.ShowModal = mrOk then begin
      Update;
      //_CAOŕ\eListViewItemɑ
      TIdFTPListItem(LItem.Data).PermissionDisplay := PermForm.FPermStr;

      //tpXt@C
      LCurrentDir := IdFTP1.RetrieveCurrentDir;
      LFileName := LCurrentDir + '/' + ListView1.Selected.Caption;
      //Site\bhőR}h쐬
      LCmdStr := 'chmod '+
                 PermForm.Edit1.Text +
                 PermForm.Edit2.Text +
                 PermForm.Edit3.Text +
                 ' ' + LFileName;
      try
        //ύXR}h𑗂
        IdFTP1.Site(LCmdStr);
      except
        MessageDlg('ANZX̕ύXɎs܂D', mtInformation, [mbOK], 0);
      end;
    end;
  finally
    FreeAndNil(PermForm);
  end;
end;

//=============================================================================
//  ListView̃_uNbNCxg
//  Item_uNbN炻̃tH_̃Xg\
//  tH_łȂ͉Ȃ
//=============================================================================
procedure TForm1.ListView1DblClick(Sender: TObject);
var
  LFTPItem : TIdFTPListItem;
begin
  if not IdFTP1.Connected then exit;

  SetButtonsEnabled(False);
  LFTPItem := TIdFTPListItem(ListView1.Items[ListView1.Selected.Index].Data);
  if LFTPItem.ItemType = ditDirectory then begin
    ChangeDir(ListView1.Selected.Caption);
  end;
  SetButtonsEnabled(True);
end;

//=============================================================================
//  ListView̃NbNCxg
//  ItemNbNāCItemIꂽ{^ނ̎gpۂݒ
//  ̃Tvł́CIsŜ𔽓]\̂ŁCۂɂ͈xłNbN
//  ƃt@C1ȏł΃{^gp\
//=============================================================================
procedure TForm1.ListView1Click(Sender: TObject);
begin
  SetButtonsEnabled(True);
end;

//-----------------------------------------------------------------------------
//  fBNgύXp\bh
//  [ڑ][߂]{^ƃ_uNbNłgp̂Ŋ֐ɂ
//  ftASCII̎gpɂusesIdFTPCommonKv      IdAllFTPListParsers
//  *.*Ƃƃt@Ĉ(fBNgȂ)
//-----------------------------------------------------------------------------
procedure TForm1.ChangeDir(DirName: String);
begin
  try
    if DirName <> '' then IdFTP1.ChangeDir(DirName);
    IdFTP1.List;
    //ListVieẘeItemɒl
    SetListViewItems;
  except
        raise;

    MessageDlg('fBNg܂D', mtInformation, [mbOK], 0);
    Screen.Cursor := crDefault;
  end;
end;

//-----------------------------------------------------------------------------
//  {^ނ̎gp
//-----------------------------------------------------------------------------
procedure TForm1.SetButtonsEnabled(Flag: Boolean);
begin
  if Flag then begin
    btnConnect.Enabled := Flag;
    if IdFTP1.Connected then begin
      btnBackDir.Enabled    := Flag and (IdFTP1.RetrieveCurrentDir <> '/');

      btnReName.Enabled     := Flag and (ListView1.Selected <> nil) and
                                        (IdFTP1.RetrieveCurrentDir <> '/');
      btnCreateDir.Enabled  := Flag and (IdFTP1.RetrieveCurrentDir <> '/');

      btnDelete.Enabled     := Flag and (ListView1.Selected <> nil) and
                                        (IdFTP1.RetrieveCurrentDir <> '/');

      btnPermission.Enabled := Flag and (ListView1.Selected <> nil) and
                                        (IdFTP1.RetrieveCurrentDir <> '/');
    end else begin
      btnBackDir.Enabled    := False;
      btnReName.Enabled     := False;
      btnCreateDir.Enabled  := False;
      btnDelete.Enabled     := False;
      btnPermission.Enabled := False;
    end;
  end else begin
    btnConnect.Enabled    := Flag;
    btnBackDir.Enabled    := Flag;
    btnReName.Enabled     := Flag;
    btnCreateDir.Enabled  := Flag;
    btnDelete.Enabled     := Flag;
    btnPermission.Enabled := Flag;
  end;
end;

//-----------------------------------------------------------------------------
//  ListView̃\[g֐CustomSort̃R[obN֐
//  GNXv[̃\[gƓ邽߂̍HvĂ
//  NbNɉă\[g邽߂
//  SortColumnIndex      NbNJԍŃO[oϐ
//  SortColum[̔ԍ]  JƂɏ~ێz(1-1)
//  gpĂ
//-----------------------------------------------------------------------------
function ItemsSort(Item1, Item2: TListItem; ParamSort: integer): integer;stdcall;
var
  LDir1  : Boolean;
  LDir2  : Boolean;
  LStr1  : String;
  LStr2  : String;
  LV1    : Integer;
  LV2    : Integer;
  LDate1 : TDateTime;
  LDate2 : TDateTime;
begin
  Result := 0;

  LDir1 := TIdFTPListItem(Item1.Data).ItemType = ditDirectory;
  LDir2 := TIdFTPListItem(Item2.Data).ItemType = ditDirectory;

  case SortColumnIndex of
  0:  //t@C
    begin
      LStr1 := Item1.Caption;
      LStr2 := Item2.Caption;
      //ǂtH_ǂtH_łȂꍇ
      if (LDir1 and LDir2) or not(LDir1 or LDir2) then begin
        Result := SortColum[SortColumnIndex] * CompareText(LStr1, LStr2);
      end else
      //ǂtH_̏ꍇ
      if (LDir1 and LDir2) then begin
        Result := SortColum[SortColumnIndex] * CompareText(LStr1, LStr2);
      end else
      //Item1ɊŶtH_̏ꍇ
      if LDir1 then begin
        Result := - SortColum[SortColumnIndex];
      end else
      //Item2ɊŶtH_̏ꍇ
      if LDir2 then begin
        Result := SortColum[SortColumnIndex];
      end;
    end;
  1: //t@CTCY
    begin
      LV1 := TIdFTPListItem(Item1.Data).Size;
      LV2 := TIdFTPListItem(Item2.Data).Size;
      //ǂtH_ǂtH_łȂꍇ
      if (LDir1 and LDir2) or not(LDir1 or LDir2) then begin
        Result := SortColum[SortColumnIndex] * CompareValue(LV1, LV2);
      end else
      //ǂtH_̏ꍇ
      if (LDir1 and LDir2) then begin
        Result := SortColum[SortColumnIndex] * CompareValue(LV1, LV2);
      end else
      //Item1ɊŶtH_̏ꍇ
      if LDir1 then begin
        Result := -SortColum[SortColumnIndex];
      end else
      //Item2ɊŶtH_̏ꍇ
      if LDir2 then begin
        Result := SortColum[SortColumnIndex];
      end;
    end;
  2: //XV
    begin
      LDate1 := TIdFTPListItem(Item1.Data).ModifiedDate;
      LDate2 := TIdFTPListItem(Item2.Data).ModifiedDate;
      //ǂtH_ǂtH_łȂꍇ
      if (LDir1 and LDir2) or not(LDir1 or LDir2) then begin
        Result := SortColum[SortColumnIndex] * CompareDateTime(LDate1, LDate2);
      end else
      //ǂtH_̏ꍇ
      if (LDir1 and LDir2) then begin
        Result := SortColum[SortColumnIndex] * CompareValue(LDate1, LDate2);
      end else
      //Item1ɊŶtH_̏ꍇ
      if LDir1 then begin
        Result := -SortColum[SortColumnIndex];
      end else
      //Item2ɊŶtH_̏ꍇ
      if LDir2 then begin
        Result := SortColum[SortColumnIndex];
      end;
    end;
  end;
end;

end.
