//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  IdFTPR|gpăT[õfBNgT[\ t@C\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2007N1116
//    EJ
//
//  2011N0121
//    EDelphi 2010, XE, Indy 10.5.7ȍ~Ή̃R[hɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro + Indy 10 (Ver 10.5.7)
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdFTP,
  IdExplicitTLSClientServerBase;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    btnConnect: TButton;
    btnBackDir: TButton;
    TreeView1: TTreeView;
    IdFTP1: TIdFTP;
    procedure btnConnectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnBackDirClick(Sender: TObject);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    FIniFileName : String;
    FRootNode    : TTreeNode;
    function ChangeDirAndSetTreeItems(ADir: String; Node: TTreeNode;
      DirFlag:Boolean): Boolean;
    function GetFullPathFromNode(Node: TTreeNode): String;
    function GetFileExtIcon(FileName: String; Attrib:Cardinal;
        OpenFlag:Boolean): Integer;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  ShellAPI, CommCtrl, IniFiles, IdFTPList, IdAllFTPListParsers;

{$R *.dfm}

//=============================================================================
//  e평Ԃ̐ݒ
//
//  VXeC[Wł͂ȂCTImageListgpꍇCwiڗȂFɂ
//  ĂȂXP,2000ŎsۂclNone̍F̂܂ܕ\Ă܂
//    ImageList1.BkColor := TreeView1.Color;
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LSHFileInfo    : TSHFileInfo ;
  LImgListHandle : THandle;
begin
  btnConnect.Enabled := True;

  //tH[JXȂIm[hW\
  TreeView1.HideSelection := False;
  //eXgȂ̂ŕsIs
  TreeView1.MultiSelect := False;
  //lɒڕҏW͕s
  TreeView1.ReadOnly := True;
  //fBNg͕\p
  LabeledEdit4.ReadOnly := True;
  //߂{^
  btnBackDir.Enabled := False;

  //RRg[̃CjVCY
  InitCommonControls;
  //VXẽc[r[̃nh擾
  LImgListHandle := SHGetFileInfo('',
                                  0,
                                  LSHFileInfo,
                                  SizeOf(LSHFileInfo),
                                  SHGFI_SMALLICON or
                                  SHGFI_OPENICON or
                                  SHGFI_SYSICONINDEX);
  TreeView_SetImageList(TreeView1.Handle, LImgListHandle, TVSIL_NORMAL);
  TreeView1.Items.Clear;
end;

//=============================================================================
//  tH[\̏
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  AIni : TInifile;
begin
  //Init@CpX[hǏoĕ\
  FIniFileName := '..\FTPInfo.ini';
  AIni         := TIniFile.Create(FIniFileName);

  try
   if FileExists(FIniFileName) then begin
     LabeledEdit1.Text := AIni.ReadString('FTPInfo', 'ServerName', '');
     LabeledEdit2.Text := AIni.ReadString('FTPInfo', 'UserID',     '');
     LabeledEdit3.Text := AIni.ReadString('FTPInfo', 'PassWord',   '');
   end;
  finally
    FreeAndNil(AIni);
  end;
end;

//=============================================================================
//  ݒInit@Cɕۑ
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  AIni : TInifile;
begin
  AIni := TIniFile.Create(FIniFileName);

  try
    try
      AIni.WriteString('FTPInfo', 'ServerName', LabeledEdit1.Text);
      AIni.WriteString('FTPInfo', 'UserID',     LabeledEdit2.Text);
      AIni.WriteString('FTPInfo', 'PassWord',   LabeledEdit3.Text);
    except
    end;
  finally
    FreeAndNil(AIni);
  end;
end;

//=============================================================================
//  ڑFTPT[o̎wfBNg̈ꗗ擾
//=============================================================================
procedure TForm1.btnConnectClick(Sender: TObject);
var
  LRootDir    : String;
  LFileAttrib : Cardinal;
begin
  btnConnect.Enabled := False;

  if IdFTP1.Connected then begin
    IdFTP1.Disconnect;
    btnConnect.Caption := 'ڑ';
    TreeView1.Items.Clear;
  end else begin
    IdFTP1.Host     := LabeledEdit1.Text;
    IdFTP1.Username := LabeledEdit2.Text;
    IdFTP1.Password := LabeledEdit3.Text;

    try
      IdFTP1.Connect;
      TreeView1.Items.Clear;
      FRootNode := nil;

      //[gm[h
      LRootDir := '/';
      FRootNode := TreeView1.Items.Add(nil, LRootDir);

      //FRootNodẽACR
      LFileAttrib := FILE_ATTRIBUTE_DIRECTORY;
      FRootNode.ImageIndex    := GetFileExtIcon('', LFileAttrib, False);
      FRootNode.SelectedIndex := GetFileExtIcon('', LFileAttrib, True);

      //c[r[쐬
      ChangeDirAndSetTreeItems(LRootDir, FRootNode, True);
      btnBackDir.Enabled := True;
      FRootNode.Expanded := True;
    except
      MessageDlg('ڑɎs܂D', mtInformation, [mbOK], 0);
    end;
    if IdFTP1.Connected then begin
      btnConnect.Caption := 'ؒf';
    end else begin
      btnConnect.Caption := 'ڑ';
      TreeView1.Items.Clear;
    end;
  end;

  btnConnect.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  ADirfBNg̃tH_Xg
//  TIdFTPListItem̎gpɂusesIdFTPListKv
//  \[g͂ĂȂŎ擾
//-----------------------------------------------------------------------------
function TForm1.ChangeDirAndSetTreeItems(ADir: String; Node: TTreeNode;
  DirFlag: Boolean): Boolean;
var
  i           : Integer;
  LCount      : Integer;
  LFileName   : String;
  LAddNode    : TTreeNode;
  LListItem   : TIdFTPListItem;
  LDirCnt     : Integer;
  LFileAttrib : Cardinal;
begin
  Result := False;

  IdFTP1.ChangeDir(ADir);
  IdFTP1.List;

  LCount := IdFTP1.DirectoryListing.Count;

  if LCount > 0 then begin
    //܂fBNgc[ɒǉĂ
    for i := 0 to LCount - 1 do begin
      LListItem := IdFTP1.DirectoryListing[i];
      LFileName := LListItem.FileName;
      if (LFileName = '.') or (LFileName = '..') then Continue;

      if LListItem.ItemType = ditDirectory then begin
        LFileAttrib := FILE_ATTRIBUTE_DIRECTORY;
        LAddNode    := TreeView1.Items.AddChild(Node,LFileName);

        LAddNode.ImageIndex    := GetFileExtIcon(LFileName, LFileAttrib, False);
        LAddNode.SelectedIndex := GetFileExtIcon(LFileName, LFileAttrib, True);

        //TIdFTPListItemDatavpeB1114ԖڂɃfBNgɑ
        //fBNgĂ̂łgp
        LDirCnt := StrToIntDef(Copy(LListItem.Data, 11, 4), 0) - 2;
        //t@C\ꍇADirCnt>0ł͂ȂADirCnt>=0
        if LDirCnt >= 0 then begin
          LAddNode.HasChildren := True;
        end;
      end;
    end;

    //Ƀt@Ĉ݂ǉĂ
    for i := 0 to LCount - 1 do begin
      LListItem := IdFTP1.DirectoryListing[i];
      LFileName := LListItem.FileName;
      if (LFileName = '.') or (LFileName = '..') then Continue;

      if LListItem.ItemType <> ditDirectory then begin
        LFileAttrib := FILE_ATTRIBUTE_NORMAL;
        LAddNode    := TreeView1.Items.AddChild(Node, LFileName);

        LAddNode.ImageIndex    := GetFileExtIcon(LFileName, LFileAttrib, False);
        LAddNode.SelectedIndex := GetFileExtIcon(LFileName, LFileAttrib, True);
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  t@C̊gqɊ֘AtVXeC[WACR̃CfbNX擾
//  FileName̓t@C̃tpX(pX͂ȂĂ)
//  擾t@C̑Attribɗ^
//  JACR擾ꍇOpenFlagTureɂ
//-----------------------------------------------------------------------------
function TForm1.GetFileExtIcon(FileName: String; Attrib: Cardinal;
    OpenFlag:Boolean ): Integer;
var
  LSHFileInfo : TSHFileinfo;
  LpszPath    : String;
  LuFlags     : Cardinal;
begin
  LuFlags := SHGFI_USEFILEATTRIBUTES or SHGFI_SYSICONINDEX or SHGFI_SMALLICON;

  if OpenFlag then begin
    LuFlags  := LuFlags or SHGFI_OPENICON;
  end;

  if Attrib=FILE_ATTRIBUTE_DIRECTORY then begin
    LpszPath := '*';
  end else begin
    LpszPath := '*' + ExtractFileExt(Filename);
  end;

  SHGetFileInfo(PChar(LpszPath),
                Attrib,
                LSHFileInfo,
                SizeOf(TSHFileInfo),
                LuFlags);
  Result := LSHFileInfo.iIcon;
end;

//=============================================================================
//  [߂]{^
//  P̊Kw̃fBNgɈړ
//=============================================================================
procedure TForm1.btnBackDirClick(Sender: TObject);
var
  LNode : TTreeNode;
begin
  if not IdFTP1.Connected then exit;

  LNode := TreeView1.Selected;
  if LNode = FRootNode then exit;

  IdFTP1.ChangeDirUp;
  TreeView1.Selected := LNode.Parent;
end;

//=============================================================================
//  m[hWJJn̎̃Cxg
//  ݂̃fBNg̃fBNg̃Xg쐬
//=============================================================================
procedure TForm1.TreeView1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var
  LFullDir : String;
begin
  if not IdFTP1.Connected then exit;

  if Node.HasChildren then begin
    if Node.Count = 0 then begin
      LFullDir := GetFullPathFromNode(Node);
      TreeView1.Items.BeginUpdate;
      Screen.Cursor := crHourglass;
      ChangeDirAndSetTreeItems(LFullDir, Node, True);

      TreeView1.Items.EndUpdate;
      Screen.Cursor:=crDefault;
    end;
  end;
end;

//=============================================================================
//  OnCollapsed(m[h)Cxgp\bh
//  m[hWJɃGNXv[Ƃ͈ႢCO̓WJԂČȂ
//  ʃm[h폜Dm[hWJɃtH_ꗗĎ擾ƂD
//  ēWJ̎ɑÕc[ԂČ̂ȍҍD݂̎dl
//  ēxm[hWJ鎞͍ŐV̏ɂȂĂ闘_
//=============================================================================
procedure TForm1.TreeView1Collapsed(Sender: TObject; Node: TTreeNode);
var
  LFlag : Boolean;
begin
  if not IdFTP1.Connected then exit;

  Screen.Cursor := crHourGlass;

  TreeView1.Items.BeginUpdate;
  LFlag := Node.Count > 0;
  Node.DeleteChildren;
  TreeView1.Items.EndUpdate;
  Node.HasChildren := LFlag;

  Screen.Cursor := crDefault;
end;

//=============================================================================
//  Im[hύXɂȂLabeledEdit4Ɍ݂̐΃pX\
//=============================================================================
procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  LFullDir : String;
begin
  LFullDir := GetFullPathFromNode(Node);

  try
    IdFTP1.ChangeDir(LFullDir);
  except
    //t@C̏ꍇ̓fBNgύX͕s
  end;
  LabeledEdit4.Text := IdFTP1.RetrieveCurrentDir;

  btnBackDir.Enabled := Node <> FRootNode;
end;

//-----------------------------------------------------------------------------
//  m[h΃pX߂
//  ̂悤񏈗sȂĂTreeVieẘeItemDatavpeBɐ΃pX
//  Ă@
//-----------------------------------------------------------------------------
function TForm1.GetFullPathFromNode(Node: TTreeNode): String;
var
  LNowNode   : TTreeNode;
  LSearchDir : String;
begin
  LNowNode   := Node;
  LSearchDir := Node.Text;

  while True do begin
    if LNowNode = FRootNode then break;
    LSearchDir := LNowNode.Parent.Text + '/' + LSearchDir;
    LNowNode   := LNowNode.Parent;
  end;
  Result := '/' + LSearchDir;
end;

end.
