//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  IdFTPR|gpăT[õfBNg폜
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2007N1116
//    EJ
//
//  2011N0121
//    EDelphi 2010, XE, Indy 10.5.7ȍ~Ή̃R[hɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro + Indy 10 (Ver 10.5.7)
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdFTP,
  IdExplicitTLSClientServerBase;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    btnConnect: TButton;
    IdFTP1: TIdFTP;
    btnDeleteDir: TButton;
    ListBox1: TListBox;
    procedure btnConnectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDeleteDirClick(Sender: TObject);
  private
    { Private 錾 }
    FIniFileName : String;
    FBaseDir : String;
    procedure ChangeDirAndListDir(ADir: String);
    function DeleteDirFiles(Adir: String): Boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  ShellAPI, CommCtrl, IniFiles, IdFTPList, IdAllFTPListParsers;

{$R *.dfm}

//=============================================================================
//  tH[\̏
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LIni : TInifile;
begin
  btnConnect.Enabled := True;

  //폜{^
  btnDeleteDir.Enabled := False;

  //Init@CpX[hǏoĕ\
  FIniFileName := '..\FTPInfo.ini';
  LIni         := TIniFile.Create(FIniFileName);

  try
   if FileExists(FIniFileName) then begin
     LabeledEdit1.Text := LIni.ReadString('FTPInfo', 'ServerName', '');
     LabeledEdit2.Text := LIni.ReadString('FTPInfo', 'UserID',     '');
     LabeledEdit3.Text := LIni.ReadString('FTPInfo', 'PassWord',   '');
     LabeledEdit4.Text := LIni.ReadString('Others',  'DeleteDir',  '');
   end;
  finally
    FreeAndNil(LIni);
  end;
end;

//=============================================================================
//  ݒInit@Cɕۑ
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  LIni : TInifile;
begin
  LIni := TIniFile.Create(FIniFileName);
  try
    try
      LIni.WriteString('FTPInfo', 'ServerName', LabeledEdit1.Text);
      LIni.WriteString('FTPInfo', 'UserID',     LabeledEdit2.Text);
      LIni.WriteString('FTPInfo', 'PassWord',   LabeledEdit3.Text);
      LIni.WriteString('Others',  'DeleteDir',  LabeledEdit4.Text);
    except
    end;
  finally
    FreeAndNil(LIni);
  end;
end;

//=============================================================================
//  ڑFTPT[o̎wfBNg̑SẴTufBNgꗗ擾
//=============================================================================
procedure TForm1.btnConnectClick(Sender: TObject);
begin
  btnConnect.Enabled := False;

  if IdFTP1.Connected then begin
    IdFTP1.Disconnect;
    btnConnect.Caption := 'ڑ';
    ListBox1.Items.Clear;
  end else begin
    IdFTP1.Host     := LabeledEdit1.Text;
    IdFTP1.Username := LabeledEdit2.Text;
    IdFTP1.Password := LabeledEdit3.Text;

    try
      if IdFTP1.Connected=False then IdFTP1.Connect;
      try
        ListBox1.Items.Clear;
        ListBox1.Items.BeginUpdate;
        //ΏۂƂȂtH_
        FBaseDir := LabeledEdit4.Text;
        //폜Ώۂ̃fBNg(fBNgي܂)t@CXg쐬
        ChangeDirAndListDir(FBaseDir);
        ListBox1.Items.EndUpdate;
        btnDeleteDir.Enabled := True;
      except
        MessageDlg('fBNg݂܂D', mtInformation, [mbOK], 0);
      end;
    except
      MessageDlg('ڑɎs܂D', mtInformation, [mbOK], 0);
    end;

    if IdFTP1.Connected then begin
      btnConnect.Caption := 'ؒf';
    end else begin
      btnConnect.Caption := 'ڑ';
      ListBox1.Items.Clear;
    end;
  end;

  btnConnect.Enabled := True;
end;

//=============================================================================
//  [폜]{^
//  ListBoxɃXgfBNgƂ̒̃t@C폜
//=============================================================================
procedure TForm1.btnDeleteDirClick(Sender: TObject);
var
  i        : Integer;
  LTheText : String;
begin
  if not IdFTP1.Connected then exit;

  Screen.Cursor := crHourGlass;
  //fBNg̃t@CƃfBNgg폜
  //Kw̐[fBNg폜̂ŋt
  for i := ListBox1.Items.Count - 1 downto 0 do begin
    DeleteDirFiles(ListBox1.Items[i]);
  end;
  //ŌɑΏۂ̑匳̃fBNg̃t@CƃfBNgg폜
  DeleteDirFiles(FBaseDir);
  Screen.Cursor := crDefault;

  LTheText := '폜܂' + sLineBreak
            + '\̃fBNg͊ɑ݂܂';
  MessageDlg(LTheText, mtInformation, [mbOK], 0);
end;

//-----------------------------------------------------------------------------
//  폜ΏۂƂȂfBNg̃XgċAIɌListBoxɒǉĂ
//  ̃Tvł̓eXg̎ɊmFł悤ListBoxɃfBNgX
//  gĂ邪CۂɂTStringListł낤
//
//  Xg쐬ȂŁC̃[`̒ō폜ĂĂ悢CXg
//  ΍폜ȂǂC(JEgĂ)폜̌xƋɕ\ł
//
//  ADir͐΃pXŗ^
//  Indy10łList\bḧ͕sv
//  TIdFTPListItem̎gpɂusesIdFTPListKv
//-----------------------------------------------------------------------------
procedure TForm1.ChangeDirAndListDir(ADir: String);
var
  LFileList : TStringList;
  i         : Integer;
  LCount    : Integer;
  LListItem : TIdFTPListItem;
  LFileName : String;
  LDirCnt   : Integer;
  LCurDir   : String;
begin
  LFileList := TStringList.Create;
  try
    IdFTP1.ChangeDir(ADir);
    IdFTP1.List(LFileList);

    //List\bhsDirectoryListingŃt@C̃Xg擾ł
    LCount := IdFTP1.DirectoryListing.Count;

    //DirectroyListing͐VList\bhsƏĂ܂
    //čċȀꍇ͗płȂ̂ŕʃXg쐬
    LFileList.Clear;
    for i := 0 to LCount - 1 do begin
      LListItem := IdFTP1.DirectoryListing[i];
      LFileName := LListItem.FileName;
      if (LFileName = '.') or (LFileName = '..') then Continue;

      if LListItem.ItemType = ditDirectory then begin
        LCurDir := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
        ListBox1.Items.Add(LCurDir);
        LDirCnt := StrToIntDef(Copy(LListItem.Data, 11, 4), 0) - 2;
        if LDirCnt > 0 then begin
          LFileList.Add(LCurDir);
        end;
      end;
    end;

    //̎_SLɉwfBNg΃pXœĂ
    //wfBNgċAIɌListBoxItemɒǉĂ
    for i := 0 to LFileList.Count - 1 do begin
      ChangeDirAndListDir(LFileList[i]);
    end;
  finally
    FreeAndNil(LFileList);
  end;
end;

//-----------------------------------------------------------------------------
//  Ŏw肷fBNg̃t@CSĂƂ̃fBNg폜
//
//  ADir͐΃pXŗ^
//  Indy10łList\bḧ͕sv
//-----------------------------------------------------------------------------
function TForm1.DeleteDirFiles(Adir: String): Boolean;
var
  LFileList : TStringList;
  i         : Integer;
  LCount    : Integer;
  LListItem : TIdFTPListItem;
  LFileName : String;
begin
  Result := True;

  LFileList := TStringList.Create;
  try
    IdFTP1.ChangeDir(ADir);
    IdFTP1.List(LFileList);
  finally
    FreeAndNil(LFileList);
  end;

  LCount := IdFTP1.DirectoryListing.Count;
  try
    for i := 0 to LCount - 1 do begin
      LListItem := IdFTP1.DirectoryListing[i];
      LFileName := LListItem.FileName;
      if (LFileName = '.') or (LFileName = '..') then Continue;

      if LListItem.ItemType <> ditDirectory then begin
        IdFTP1.Delete(LFileName);
      end;
    end;
    IdFTP1.ChangeDirUp;
    IdFTP1.RemoveDir(ADir);
  except
    Result := False;
  end;
end;

end.
